// +build !ignore_autogenerated

// This file was autogenerated by openapi-gen. Do not edit it manually!

package v1alpha1

import (
	spec "github.com/go-openapi/spec"
	common "k8s.io/kube-openapi/pkg/common"
)

func GetOpenAPIDefinitions(ref common.ReferenceCallback) map[string]common.OpenAPIDefinition {
	return map[string]common.OpenAPIDefinition{
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Arguments": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Arguments to a template",
					Properties: map[string]spec.Schema{
						"parameters": {
							SchemaProps: spec.SchemaProps{
								Description: "Parameters is the list of parameters to pass to the template or workflow",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Parameter"),
										},
									},
								},
							},
						},
						"artifacts": {
							SchemaProps: spec.SchemaProps{
								Description: "Artifacts is the list of artifacts to pass to the template or workflow",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Artifact"),
										},
									},
								},
							},
						},
					},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Artifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Parameter"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Artifact": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Artifact indicates an artifact to place at a specified path",
					Properties: map[string]spec.Schema{
						"name": {
							SchemaProps: spec.SchemaProps{
								Description: "name of the artifact. must be unique within a template's inputs/outputs.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"path": {
							SchemaProps: spec.SchemaProps{
								Description: "Path is the container path to the artifact",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"mode": {
							SchemaProps: spec.SchemaProps{
								Description: "mode bits to use on this file, must be a value between 0 and 0777 set when loading input artifacts.",
								Type:        []string{"integer"},
								Format:      "int32",
							},
						},
						"from": {
							SchemaProps: spec.SchemaProps{
								Description: "From allows an artifact to reference an artifact from a previous step",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"s3": {
							SchemaProps: spec.SchemaProps{
								Description: "S3 contains S3 artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.S3Artifact"),
							},
						},
						"git": {
							SchemaProps: spec.SchemaProps{
								Description: "Git contains git artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.GitArtifact"),
							},
						},
						"http": {
							SchemaProps: spec.SchemaProps{
								Description: "HTTP contains HTTP artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.HTTPArtifact"),
							},
						},
						"artifactory": {
							SchemaProps: spec.SchemaProps{
								Description: "Artifactory contains artifactory artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactoryArtifact"),
							},
						},
						"raw": {
							SchemaProps: spec.SchemaProps{
								Description: "Raw contains raw artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.RawArtifact"),
							},
						},
						"globalName": {
							SchemaProps: spec.SchemaProps{
								Description: "GlobalName exports an output artifact to the global scope, making it available as '{{workflow.outputs.artifacts.XXXX}} and in workflow.status.outputs.artifacts",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
					Required: []string{"name"},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactoryArtifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.GitArtifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.HTTPArtifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.RawArtifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.S3Artifact"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactLocation": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "ArtifactLocation describes a location for a single or multiple artifacts. It is used as single artifact in the context of inputs/outputs (e.g. outputs.artifacts.artname). It is also used to describe the location of multiple artifacts such as the archive location of a single workflow step, which the executor will use as a default location to store its files.",
					Properties: map[string]spec.Schema{
						"s3": {
							SchemaProps: spec.SchemaProps{
								Description: "S3 contains S3 artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.S3Artifact"),
							},
						},
						"git": {
							SchemaProps: spec.SchemaProps{
								Description: "Git contains git artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.GitArtifact"),
							},
						},
						"http": {
							SchemaProps: spec.SchemaProps{
								Description: "HTTP contains HTTP artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.HTTPArtifact"),
							},
						},
						"artifactory": {
							SchemaProps: spec.SchemaProps{
								Description: "Artifactory contains artifactory artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactoryArtifact"),
							},
						},
						"raw": {
							SchemaProps: spec.SchemaProps{
								Description: "Raw contains raw artifact location details",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.RawArtifact"),
							},
						},
					},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactoryArtifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.GitArtifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.HTTPArtifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.RawArtifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.S3Artifact"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactoryArtifact": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "ArtifactoryArtifact is the location of an artifactory artifact",
					Properties: map[string]spec.Schema{
						"url": {
							SchemaProps: spec.SchemaProps{
								Description: "URL of the artifact",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"usernameSecret": {
							SchemaProps: spec.SchemaProps{
								Description: "UsernameSecret is the secret selector to the repository username",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
						"passwordSecret": {
							SchemaProps: spec.SchemaProps{
								Description: "PasswordSecret is the secret selector to the repository password",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
					},
					Required: []string{"url"},
				},
			},
			Dependencies: []string{
				"k8s.io/api/core/v1.SecretKeySelector"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactoryAuth": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "ArtifactoryAuth describes the secret selectors required for authenticating to artifactory",
					Properties: map[string]spec.Schema{
						"usernameSecret": {
							SchemaProps: spec.SchemaProps{
								Description: "UsernameSecret is the secret selector to the repository username",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
						"passwordSecret": {
							SchemaProps: spec.SchemaProps{
								Description: "PasswordSecret is the secret selector to the repository password",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
					},
				},
			},
			Dependencies: []string{
				"k8s.io/api/core/v1.SecretKeySelector"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.DAGTask": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "DAGTask represents a node in the graph during DAG execution",
					Properties: map[string]spec.Schema{
						"name": {
							SchemaProps: spec.SchemaProps{
								Description: "Name is the name of the target",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"template": {
							SchemaProps: spec.SchemaProps{
								Description: "Name of template to execute",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"arguments": {
							SchemaProps: spec.SchemaProps{
								Description: "Arguments are the parameter and artifact arguments to the template",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Arguments"),
							},
						},
						"dependencies": {
							SchemaProps: spec.SchemaProps{
								Description: "Dependencies are name of other targets which this depends on",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
					},
					Required: []string{"name", "template"},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Arguments"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.DAGTemplate": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "DAGTemplate is a template subtype for directed acyclic graph templates",
					Properties: map[string]spec.Schema{
						"target": {
							SchemaProps: spec.SchemaProps{
								Description: "Target are one or more names of targets to execute in a DAG",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"tasks": {
							SchemaProps: spec.SchemaProps{
								Description: "Tasks are a list of DAG tasks",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.DAGTask"),
										},
									},
								},
							},
						},
					},
					Required: []string{"tasks"},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.DAGTask"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.GitArtifact": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "GitArtifact is the location of an git artifact",
					Properties: map[string]spec.Schema{
						"repo": {
							SchemaProps: spec.SchemaProps{
								Description: "Repo is the git repository",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"revision": {
							SchemaProps: spec.SchemaProps{
								Description: "Revision is the git commit, tag, branch to checkout",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"usernameSecret": {
							SchemaProps: spec.SchemaProps{
								Description: "UsernameSecret is the secret selector to the repository username",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
						"passwordSecret": {
							SchemaProps: spec.SchemaProps{
								Description: "PasswordSecret is the secret selector to the repository password",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
					},
					Required: []string{"repo"},
				},
			},
			Dependencies: []string{
				"k8s.io/api/core/v1.SecretKeySelector"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.HTTPArtifact": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "HTTPArtifact allows an file served on HTTP to be placed as an input artifact in a container",
					Properties: map[string]spec.Schema{
						"url": {
							SchemaProps: spec.SchemaProps{
								Description: "URL of the artifact",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
					Required: []string{"url"},
				},
			},
			Dependencies: []string{},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Inputs": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Inputs are the mechanism for passing parameters, artifacts, volumes from one template to another",
					Properties: map[string]spec.Schema{
						"parameters": {
							SchemaProps: spec.SchemaProps{
								Description: "Parameters are a list of parameters passed as inputs",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Parameter"),
										},
									},
								},
							},
						},
						"artifacts": {
							SchemaProps: spec.SchemaProps{
								Description: "Artifact are a list of artifacts passed as inputs",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Artifact"),
										},
									},
								},
							},
						},
					},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Artifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Parameter"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Item": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Type:   Item{}.OpenAPISchemaType(),
					Format: Item{}.OpenAPISchemaFormat(),
				},
			},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Metadata": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Pod metdata",
					Properties: map[string]spec.Schema{
						"annotations": {
							SchemaProps: spec.SchemaProps{
								Type: []string{"object"},
								AdditionalProperties: &spec.SchemaOrBool{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
						"labels": {
							SchemaProps: spec.SchemaProps{
								Type: []string{"object"},
								AdditionalProperties: &spec.SchemaOrBool{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
					},
				},
			},
			Dependencies: []string{},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Outputs": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Outputs hold parameters, artifacts, and results from a step",
					Properties: map[string]spec.Schema{
						"parameters": {
							SchemaProps: spec.SchemaProps{
								Description: "Parameters holds the list of output parameters produced by a step",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Parameter"),
										},
									},
								},
							},
						},
						"artifacts": {
							SchemaProps: spec.SchemaProps{
								Description: "Artifacts holds the list of output artifacts produced by a step",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Artifact"),
										},
									},
								},
							},
						},
						"result": {
							SchemaProps: spec.SchemaProps{
								Description: "Result holds the result (stdout) of a script template",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Artifact", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Parameter"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Parameter": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Parameter indicate a passed string parameter to a service template with an optional default value",
					Properties: map[string]spec.Schema{
						"name": {
							SchemaProps: spec.SchemaProps{
								Description: "Name is the parameter name",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"default": {
							SchemaProps: spec.SchemaProps{
								Description: "Default is the default value to use for an input parameter if a value was not supplied",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"value": {
							SchemaProps: spec.SchemaProps{
								Description: "Value is the literal value to use for the parameter. If specified in the context of an input parameter, the value takes precedence over any passed values",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"valueFrom": {
							SchemaProps: spec.SchemaProps{
								Description: "ValueFrom is the source for the output parameter's value",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ValueFrom"),
							},
						},
						"globalName": {
							SchemaProps: spec.SchemaProps{
								Description: "GlobalName exports an output parameter to the global scope, making it available as '{{workflow.outputs.parameters.XXXX}} and in workflow.status.outputs.parameters",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
					Required: []string{"name"},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ValueFrom"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.RawArtifact": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "RawArtifact allows raw string content to be placed as an artifact in a container",
					Properties: map[string]spec.Schema{
						"data": {
							SchemaProps: spec.SchemaProps{
								Description: "Data is the string contents of the artifact",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
					Required: []string{"data"},
				},
			},
			Dependencies: []string{},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ResourceTemplate": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "ResourceTemplate is a template subtype to manipulate kubernetes resources",
					Properties: map[string]spec.Schema{
						"action": {
							SchemaProps: spec.SchemaProps{
								Description: "Action is the action to perform to the resource. Must be one of: get, create, apply, delete, replace",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"manifest": {
							SchemaProps: spec.SchemaProps{
								Description: "Manifest contains the kubernetes manifest",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"successCondition": {
							SchemaProps: spec.SchemaProps{
								Description: "SuccessCondition is a label selector expression which describes the conditions of the k8s resource in which it is acceptable to proceed to the following step",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"failureCondition": {
							SchemaProps: spec.SchemaProps{
								Description: "FailureCondition is a label selector expression which describes the conditions of the k8s resource in which the step was considered failed",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
					Required: []string{"action", "manifest"},
				},
			},
			Dependencies: []string{},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.RetryStrategy": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "RetryStrategy provides controls on how to retry a workflow step",
					Properties: map[string]spec.Schema{
						"limit": {
							SchemaProps: spec.SchemaProps{
								Description: "Limit is the maximum number of attempts when retrying a container",
								Type:        []string{"integer"},
								Format:      "int32",
							},
						},
					},
				},
			},
			Dependencies: []string{},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.S3Artifact": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "S3Artifact is the location of an S3 artifact",
					Properties: map[string]spec.Schema{
						"endpoint": {
							SchemaProps: spec.SchemaProps{
								Description: "Endpoint is the hostname of the bucket endpoint",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"bucket": {
							SchemaProps: spec.SchemaProps{
								Description: "Bucket is the name of the bucket",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"region": {
							SchemaProps: spec.SchemaProps{
								Description: "Region contains the optional bucket region",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"insecure": {
							SchemaProps: spec.SchemaProps{
								Description: "Insecure will connect to the service with TLS",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"accessKeySecret": {
							SchemaProps: spec.SchemaProps{
								Description: "AccessKeySecret is the secret selector to the bucket's access key",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
						"secretKeySecret": {
							SchemaProps: spec.SchemaProps{
								Description: "SecretKeySecret is the secret selector to the bucket's secret key",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
						"key": {
							SchemaProps: spec.SchemaProps{
								Description: "Key is the key in the bucket where the artifact resides",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
					Required: []string{"endpoint", "bucket", "accessKeySecret", "secretKeySecret", "key"},
				},
			},
			Dependencies: []string{
				"k8s.io/api/core/v1.SecretKeySelector"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.S3Bucket": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "S3Bucket contains the access information required for interfacing with an S3 bucket",
					Properties: map[string]spec.Schema{
						"endpoint": {
							SchemaProps: spec.SchemaProps{
								Description: "Endpoint is the hostname of the bucket endpoint",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"bucket": {
							SchemaProps: spec.SchemaProps{
								Description: "Bucket is the name of the bucket",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"region": {
							SchemaProps: spec.SchemaProps{
								Description: "Region contains the optional bucket region",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"insecure": {
							SchemaProps: spec.SchemaProps{
								Description: "Insecure will connect to the service with TLS",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"accessKeySecret": {
							SchemaProps: spec.SchemaProps{
								Description: "AccessKeySecret is the secret selector to the bucket's access key",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
						"secretKeySecret": {
							SchemaProps: spec.SchemaProps{
								Description: "SecretKeySecret is the secret selector to the bucket's secret key",
								Ref:         ref("k8s.io/api/core/v1.SecretKeySelector"),
							},
						},
					},
					Required: []string{"endpoint", "bucket", "accessKeySecret", "secretKeySecret"},
				},
			},
			Dependencies: []string{
				"k8s.io/api/core/v1.SecretKeySelector"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ScriptTemplate": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "ScriptTemplate is a template subtype to enable scripting through code steps",
					Properties: map[string]spec.Schema{
						"name": {
							SchemaProps: spec.SchemaProps{
								Description: "Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"image": {
							SchemaProps: spec.SchemaProps{
								Description: "Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"command": {
							SchemaProps: spec.SchemaProps{
								Description: "Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
						"args": {
							SchemaProps: spec.SchemaProps{
								Description: "Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
						"workingDir": {
							SchemaProps: spec.SchemaProps{
								Description: "Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"ports": {
							VendorExtensible: spec.VendorExtensible{
								Extensions: spec.Extensions{
									"x-kubernetes-patch-merge-key": "containerPort",
									"x-kubernetes-patch-strategy":  "merge",
								},
							},
							SchemaProps: spec.SchemaProps{
								Description: "List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default \"0.0.0.0\" address inside a container will be accessible from the network. Cannot be updated.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.ContainerPort"),
										},
									},
								},
							},
						},
						"envFrom": {
							SchemaProps: spec.SchemaProps{
								Description: "List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.EnvFromSource"),
										},
									},
								},
							},
						},
						"env": {
							VendorExtensible: spec.VendorExtensible{
								Extensions: spec.Extensions{
									"x-kubernetes-patch-merge-key": "name",
									"x-kubernetes-patch-strategy":  "merge",
								},
							},
							SchemaProps: spec.SchemaProps{
								Description: "List of environment variables to set in the container. Cannot be updated.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.EnvVar"),
										},
									},
								},
							},
						},
						"resources": {
							SchemaProps: spec.SchemaProps{
								Description: "Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources",
								Ref:         ref("k8s.io/api/core/v1.ResourceRequirements"),
							},
						},
						"volumeMounts": {
							VendorExtensible: spec.VendorExtensible{
								Extensions: spec.Extensions{
									"x-kubernetes-patch-merge-key": "mountPath",
									"x-kubernetes-patch-strategy":  "merge",
								},
							},
							SchemaProps: spec.SchemaProps{
								Description: "Pod volumes to mount into the container's filesystem. Cannot be updated.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.VolumeMount"),
										},
									},
								},
							},
						},
						"volumeDevices": {
							VendorExtensible: spec.VendorExtensible{
								Extensions: spec.Extensions{
									"x-kubernetes-patch-merge-key": "devicePath",
									"x-kubernetes-patch-strategy":  "merge",
								},
							},
							SchemaProps: spec.SchemaProps{
								Description: "volumeDevices is the list of block devices to be used by the container. This is an alpha feature and may change in the future.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.VolumeDevice"),
										},
									},
								},
							},
						},
						"livenessProbe": {
							SchemaProps: spec.SchemaProps{
								Description: "Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes",
								Ref:         ref("k8s.io/api/core/v1.Probe"),
							},
						},
						"readinessProbe": {
							SchemaProps: spec.SchemaProps{
								Description: "Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes",
								Ref:         ref("k8s.io/api/core/v1.Probe"),
							},
						},
						"lifecycle": {
							SchemaProps: spec.SchemaProps{
								Description: "Actions that the management system should take in response to container lifecycle events. Cannot be updated.",
								Ref:         ref("k8s.io/api/core/v1.Lifecycle"),
							},
						},
						"terminationMessagePath": {
							SchemaProps: spec.SchemaProps{
								Description: "Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"terminationMessagePolicy": {
							SchemaProps: spec.SchemaProps{
								Description: "Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"imagePullPolicy": {
							SchemaProps: spec.SchemaProps{
								Description: "Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"securityContext": {
							SchemaProps: spec.SchemaProps{
								Description: "Security options the pod should run with. More info: https://kubernetes.io/docs/concepts/policy/security-context/ More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/",
								Ref:         ref("k8s.io/api/core/v1.SecurityContext"),
							},
						},
						"stdin": {
							SchemaProps: spec.SchemaProps{
								Description: "Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"stdinOnce": {
							SchemaProps: spec.SchemaProps{
								Description: "Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"tty": {
							SchemaProps: spec.SchemaProps{
								Description: "Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"source": {
							SchemaProps: spec.SchemaProps{
								Description: "Source contains the source code of the script to execute",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
					Required: []string{"name", "source"},
				},
			},
			Dependencies: []string{
				"k8s.io/api/core/v1.ContainerPort", "k8s.io/api/core/v1.EnvFromSource", "k8s.io/api/core/v1.EnvVar", "k8s.io/api/core/v1.Lifecycle", "k8s.io/api/core/v1.Probe", "k8s.io/api/core/v1.ResourceRequirements", "k8s.io/api/core/v1.SecurityContext", "k8s.io/api/core/v1.VolumeDevice", "k8s.io/api/core/v1.VolumeMount"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Sidecar": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Sidecar is a container which runs alongside the main container",
					Properties: map[string]spec.Schema{
						"name": {
							SchemaProps: spec.SchemaProps{
								Description: "Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"image": {
							SchemaProps: spec.SchemaProps{
								Description: "Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"command": {
							SchemaProps: spec.SchemaProps{
								Description: "Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
						"args": {
							SchemaProps: spec.SchemaProps{
								Description: "Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
						"workingDir": {
							SchemaProps: spec.SchemaProps{
								Description: "Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"ports": {
							VendorExtensible: spec.VendorExtensible{
								Extensions: spec.Extensions{
									"x-kubernetes-patch-merge-key": "containerPort",
									"x-kubernetes-patch-strategy":  "merge",
								},
							},
							SchemaProps: spec.SchemaProps{
								Description: "List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default \"0.0.0.0\" address inside a container will be accessible from the network. Cannot be updated.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.ContainerPort"),
										},
									},
								},
							},
						},
						"envFrom": {
							SchemaProps: spec.SchemaProps{
								Description: "List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.EnvFromSource"),
										},
									},
								},
							},
						},
						"env": {
							VendorExtensible: spec.VendorExtensible{
								Extensions: spec.Extensions{
									"x-kubernetes-patch-merge-key": "name",
									"x-kubernetes-patch-strategy":  "merge",
								},
							},
							SchemaProps: spec.SchemaProps{
								Description: "List of environment variables to set in the container. Cannot be updated.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.EnvVar"),
										},
									},
								},
							},
						},
						"resources": {
							SchemaProps: spec.SchemaProps{
								Description: "Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources",
								Ref:         ref("k8s.io/api/core/v1.ResourceRequirements"),
							},
						},
						"volumeMounts": {
							VendorExtensible: spec.VendorExtensible{
								Extensions: spec.Extensions{
									"x-kubernetes-patch-merge-key": "mountPath",
									"x-kubernetes-patch-strategy":  "merge",
								},
							},
							SchemaProps: spec.SchemaProps{
								Description: "Pod volumes to mount into the container's filesystem. Cannot be updated.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.VolumeMount"),
										},
									},
								},
							},
						},
						"volumeDevices": {
							VendorExtensible: spec.VendorExtensible{
								Extensions: spec.Extensions{
									"x-kubernetes-patch-merge-key": "devicePath",
									"x-kubernetes-patch-strategy":  "merge",
								},
							},
							SchemaProps: spec.SchemaProps{
								Description: "volumeDevices is the list of block devices to be used by the container. This is an alpha feature and may change in the future.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.VolumeDevice"),
										},
									},
								},
							},
						},
						"livenessProbe": {
							SchemaProps: spec.SchemaProps{
								Description: "Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes",
								Ref:         ref("k8s.io/api/core/v1.Probe"),
							},
						},
						"readinessProbe": {
							SchemaProps: spec.SchemaProps{
								Description: "Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes",
								Ref:         ref("k8s.io/api/core/v1.Probe"),
							},
						},
						"lifecycle": {
							SchemaProps: spec.SchemaProps{
								Description: "Actions that the management system should take in response to container lifecycle events. Cannot be updated.",
								Ref:         ref("k8s.io/api/core/v1.Lifecycle"),
							},
						},
						"terminationMessagePath": {
							SchemaProps: spec.SchemaProps{
								Description: "Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"terminationMessagePolicy": {
							SchemaProps: spec.SchemaProps{
								Description: "Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"imagePullPolicy": {
							SchemaProps: spec.SchemaProps{
								Description: "Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"securityContext": {
							SchemaProps: spec.SchemaProps{
								Description: "Security options the pod should run with. More info: https://kubernetes.io/docs/concepts/policy/security-context/ More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/",
								Ref:         ref("k8s.io/api/core/v1.SecurityContext"),
							},
						},
						"stdin": {
							SchemaProps: spec.SchemaProps{
								Description: "Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"stdinOnce": {
							SchemaProps: spec.SchemaProps{
								Description: "Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"tty": {
							SchemaProps: spec.SchemaProps{
								Description: "Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"mirrorVolumeMounts": {
							SchemaProps: spec.SchemaProps{
								Description: "MirrorVolumeMounts will mount the same volumes specified in the main container to the sidecar (including artifacts), at the same mountPaths. This enables dind daemon to partially see the same filesystem as the main container in order to use features such as docker volume binding",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
					},
					Required: []string{"name"},
				},
			},
			Dependencies: []string{
				"k8s.io/api/core/v1.ContainerPort", "k8s.io/api/core/v1.EnvFromSource", "k8s.io/api/core/v1.EnvVar", "k8s.io/api/core/v1.Lifecycle", "k8s.io/api/core/v1.Probe", "k8s.io/api/core/v1.ResourceRequirements", "k8s.io/api/core/v1.SecurityContext", "k8s.io/api/core/v1.VolumeDevice", "k8s.io/api/core/v1.VolumeMount"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.SuspendTemplate": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "SuspendTemplate is a template subtype to suspend a workflow at a predetermined point in time",
					Properties:  map[string]spec.Schema{},
				},
			},
			Dependencies: []string{},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Template": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Template is a reusable and composable unit of execution in a workflow",
					Properties: map[string]spec.Schema{
						"name": {
							SchemaProps: spec.SchemaProps{
								Description: "Name is the name of the template",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"inputs": {
							SchemaProps: spec.SchemaProps{
								Description: "Inputs describe what inputs parameters and artifacts are supplied to this template",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Inputs"),
							},
						},
						"outputs": {
							SchemaProps: spec.SchemaProps{
								Description: "Outputs describe the parameters and artifacts that this template produces",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Outputs"),
							},
						},
						"nodeSelector": {
							SchemaProps: spec.SchemaProps{
								Description: "NodeSelector is a selector to schedule this step of the workflow to be run on the selected node(s). Overrides the selector set at the workflow level.",
								Type:        []string{"object"},
								AdditionalProperties: &spec.SchemaOrBool{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
						"affinity": {
							SchemaProps: spec.SchemaProps{
								Description: "Affinity sets the pod's scheduling constraints Overrides the affinity set at the workflow level (if any)",
								Ref:         ref("k8s.io/api/core/v1.Affinity"),
							},
						},
						"metadata": {
							SchemaProps: spec.SchemaProps{
								Description: "Metdata sets the pods's metadata, i.e. annotations and labels",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Metadata"),
							},
						},
						"daemon": {
							SchemaProps: spec.SchemaProps{
								Description: "Deamon will allow a workflow to proceed to the next step so long as the container reaches readiness",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"steps": {
							SchemaProps: spec.SchemaProps{
								Description: "Steps define a series of sequential/parallel workflow steps",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type: []string{"array"},
											Items: &spec.SchemaOrArray{
												Schema: &spec.Schema{
													SchemaProps: spec.SchemaProps{
														Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowStep"),
													},
												},
											},
										},
									},
								},
							},
						},
						"container": {
							SchemaProps: spec.SchemaProps{
								Description: "Container is the main container image to run in the pod",
								Ref:         ref("k8s.io/api/core/v1.Container"),
							},
						},
						"script": {
							SchemaProps: spec.SchemaProps{
								Description: "Script runs a portion of code against an interpreter",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ScriptTemplate"),
							},
						},
						"resource": {
							SchemaProps: spec.SchemaProps{
								Description: "Resource template subtype which can run k8s resources",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ResourceTemplate"),
							},
						},
						"dag": {
							SchemaProps: spec.SchemaProps{
								Description: "DAG template subtype which runs a DAG",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.DAGTemplate"),
							},
						},
						"suspend": {
							SchemaProps: spec.SchemaProps{
								Description: "Suspend template subtype which can suspend a workflow when reaching the step",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.SuspendTemplate"),
							},
						},
						"sidecars": {
							SchemaProps: spec.SchemaProps{
								Description: "Sidecars is a list of containers which run alongside the main container Sidecars are automatically killed when the main container completes",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Sidecar"),
										},
									},
								},
							},
						},
						"archiveLocation": {
							SchemaProps: spec.SchemaProps{
								Description: "Location in which all files related to the step will be stored (logs, artifacts, etc...). Can be overridden by individual items in Outputs. If omitted, will use the default artifact repository location configured in the controller, appended with the <workflowname>/<nodename> in the key.",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactLocation"),
							},
						},
						"activeDeadlineSeconds": {
							SchemaProps: spec.SchemaProps{
								Description: "Optional duration in seconds relative to the StartTime that the pod may be active on a node before the system actively tries to terminate the pod; value must be positive integer This field is only applicable to container and script templates.",
								Type:        []string{"integer"},
								Format:      "int64",
							},
						},
						"retryStrategy": {
							SchemaProps: spec.SchemaProps{
								Description: "RetryStrategy describes how to retry a template when it fails",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.RetryStrategy"),
							},
						},
						"parallelism": {
							SchemaProps: spec.SchemaProps{
								Description: "Parallelism limits the max total parallel pods that can execute at the same time within the boundaries of this template invocation. If additional steps/dag templates are invoked, the pods created by those templates will not be counted towards this total.",
								Type:        []string{"integer"},
								Format:      "int64",
							},
						},
						"tolerations": {
							SchemaProps: spec.SchemaProps{
								Description: "Tolerations to apply to workflow pods.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.Toleration"),
										},
									},
								},
							},
						},
					},
					Required: []string{"name"},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ArtifactLocation", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.DAGTemplate", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Inputs", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Metadata", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Outputs", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ResourceTemplate", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.RetryStrategy", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ScriptTemplate", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Sidecar", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.SuspendTemplate", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowStep", "k8s.io/api/core/v1.Affinity", "k8s.io/api/core/v1.Container", "k8s.io/api/core/v1.Toleration"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.ValueFrom": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "ValueFrom describes a location in which to obtain the value to a parameter",
					Properties: map[string]spec.Schema{
						"path": {
							SchemaProps: spec.SchemaProps{
								Description: "Path in the container to retrieve an output parameter value from in container templates",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"jsonPath": {
							SchemaProps: spec.SchemaProps{
								Description: "JSONPath of a resource to retrieve an output parameter value from in resource templates",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"jqFilter": {
							SchemaProps: spec.SchemaProps{
								Description: "JQFilter expression against the resource object in resource templates",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"parameter": {
							SchemaProps: spec.SchemaProps{
								Description: "Parameter reference to a step or dag task in which to retrieve an output parameter value from (e.g. '{{steps.mystep.outputs.myparam}}')",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
				},
			},
			Dependencies: []string{},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Workflow": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "Workflow is the definition of a workflow resource",
					Properties: map[string]spec.Schema{
						"kind": {
							SchemaProps: spec.SchemaProps{
								Description: "Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"apiVersion": {
							SchemaProps: spec.SchemaProps{
								Description: "APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"metadata": {
							SchemaProps: spec.SchemaProps{
								Ref: ref("k8s.io/apimachinery/pkg/apis/meta/v1.ObjectMeta"),
							},
						},
						"spec": {
							SchemaProps: spec.SchemaProps{
								Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowSpec"),
							},
						},
						"status": {
							SchemaProps: spec.SchemaProps{
								Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowStatus"),
							},
						},
					},
					Required: []string{"metadata", "spec", "status"},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowSpec", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowStatus", "k8s.io/apimachinery/pkg/apis/meta/v1.ObjectMeta"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowList": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "WorkflowList is list of Workflow resources",
					Properties: map[string]spec.Schema{
						"kind": {
							SchemaProps: spec.SchemaProps{
								Description: "Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"apiVersion": {
							SchemaProps: spec.SchemaProps{
								Description: "APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"metadata": {
							SchemaProps: spec.SchemaProps{
								Ref: ref("k8s.io/apimachinery/pkg/apis/meta/v1.ListMeta"),
							},
						},
						"items": {
							SchemaProps: spec.SchemaProps{
								Type: []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Workflow"),
										},
									},
								},
							},
						},
					},
					Required: []string{"metadata", "items"},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Workflow", "k8s.io/apimachinery/pkg/apis/meta/v1.ListMeta"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowSpec": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "WorkflowSpec is the specification of a Workflow.",
					Properties: map[string]spec.Schema{
						"templates": {
							SchemaProps: spec.SchemaProps{
								Description: "Templates is a list of workflow templates used in a workflow",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Template"),
										},
									},
								},
							},
						},
						"entrypoint": {
							SchemaProps: spec.SchemaProps{
								Description: "Entrypoint is a template reference to the starting point of the workflow",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"arguments": {
							SchemaProps: spec.SchemaProps{
								Description: "Arguments contain the parameters and artifacts sent to the workflow entrypoint Parameters are referencable globally using the 'workflow' variable prefix. e.g. {{workflow.parameters.myparam}}",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Arguments"),
							},
						},
						"serviceAccountName": {
							SchemaProps: spec.SchemaProps{
								Description: "ServiceAccountName is the name of the ServiceAccount to run all pods of the workflow as.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"volumes": {
							SchemaProps: spec.SchemaProps{
								Description: "Volumes is a list of volumes that can be mounted by containers in a workflow.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.Volume"),
										},
									},
								},
							},
						},
						"volumeClaimTemplates": {
							SchemaProps: spec.SchemaProps{
								Description: "VolumeClaimTemplates is a list of claims that containers are allowed to reference. The Workflow controller will create the claims at the beginning of the workflow and delete the claims upon completion of the workflow",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.PersistentVolumeClaim"),
										},
									},
								},
							},
						},
						"parallelism": {
							SchemaProps: spec.SchemaProps{
								Description: "Parallelism limits the max total parallel pods that can execute at the same time in a workflow",
								Type:        []string{"integer"},
								Format:      "int64",
							},
						},
						"suspend": {
							SchemaProps: spec.SchemaProps{
								Description: "Suspend will suspend the workflow and prevent execution of any future steps in the workflow",
								Type:        []string{"boolean"},
								Format:      "",
							},
						},
						"nodeSelector": {
							SchemaProps: spec.SchemaProps{
								Description: "NodeSelector is a selector which will result in all pods of the workflow to be scheduled on the selected node(s). This is able to be overridden by a nodeSelector specified in the template.",
								Type:        []string{"object"},
								AdditionalProperties: &spec.SchemaOrBool{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Type:   []string{"string"},
											Format: "",
										},
									},
								},
							},
						},
						"affinity": {
							SchemaProps: spec.SchemaProps{
								Description: "Affinity sets the scheduling constraints for all pods in the workflow. Can be overridden by an affinity specified in the template",
								Ref:         ref("k8s.io/api/core/v1.Affinity"),
							},
						},
						"tolerations": {
							SchemaProps: spec.SchemaProps{
								Description: "Tolerations to apply to workflow pods.",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.Toleration"),
										},
									},
								},
							},
						},
						"imagePullSecrets": {
							SchemaProps: spec.SchemaProps{
								Description: "ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount. ImagePullSecrets are distinct from Secrets because Secrets can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet. More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("k8s.io/api/core/v1.LocalObjectReference"),
										},
									},
								},
							},
						},
						"onExit": {
							SchemaProps: spec.SchemaProps{
								Description: "OnExit is a template reference which is invoked at the end of the workflow, irrespective of the success, failure, or error of the primary workflow.",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
					Required: []string{"templates", "entrypoint"},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Arguments", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Template", "k8s.io/api/core/v1.Affinity", "k8s.io/api/core/v1.LocalObjectReference", "k8s.io/api/core/v1.PersistentVolumeClaim", "k8s.io/api/core/v1.Toleration", "k8s.io/api/core/v1.Volume"},
		},
		"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.WorkflowStep": {
			Schema: spec.Schema{
				SchemaProps: spec.SchemaProps{
					Description: "WorkflowStep is a reference to a template to execute in a series of step",
					Properties: map[string]spec.Schema{
						"name": {
							SchemaProps: spec.SchemaProps{
								Description: "Name of the step",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"template": {
							SchemaProps: spec.SchemaProps{
								Description: "Template is a reference to the template to execute as the step",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"arguments": {
							SchemaProps: spec.SchemaProps{
								Description: "Arguments hold arguments to the template",
								Ref:         ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Arguments"),
							},
						},
						"withItems": {
							SchemaProps: spec.SchemaProps{
								Description: "WithItems expands a step into multiple parallel steps from the items in the list",
								Type:        []string{"array"},
								Items: &spec.SchemaOrArray{
									Schema: &spec.Schema{
										SchemaProps: spec.SchemaProps{
											Ref: ref("github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Item"),
										},
									},
								},
							},
						},
						"withParam": {
							SchemaProps: spec.SchemaProps{
								Description: "WithParam expands a step into from the value in the parameter",
								Type:        []string{"string"},
								Format:      "",
							},
						},
						"when": {
							SchemaProps: spec.SchemaProps{
								Description: "When is an expression in which the step should conditionally execute",
								Type:        []string{"string"},
								Format:      "",
							},
						},
					},
				},
			},
			Dependencies: []string{
				"github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Arguments", "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1.Item"},
		},
	}
}
